class BrainfuckProgram:

    def __init__(self, code, ip, tape, memory, input, output):
        self.code = code
        self.ip = ip
        self.tape = tape
        self.memory = memory
        self.input = input
        self.output = output

    def instruction(self):
        self.ip += 1
        match = 1
        if self.code[self.ip] == "+":
            self.tape[self.memory] += 1
            if self.tape[self.memory] == 256:
                self.tape[self.memory] = 0
        if self.code[self.ip] == "-":
            self.tape[self.memory] -= 1
            if self.tape[self.memory] == 0:
                self.tape[self.memory] = 256
        if self.code[self.ip] == "[":
            match = 1
            if self.tape[self.memory] == 0:
                while match > 0:
                    self.ip += 1
                    if self.code[self.ip] == "]":
                        match -= 1
                    elif self.code[self.ip] == "[":
                        match += 1
        if self.code[self.ip] == "]":
            match = 1
            if self.tape[self.memory] != 0:
                while match > 0:
                    self.ip -= 1
                    if self.code[self.ip] == "[":
                        match -= 1
                    elif self.code[self.ip] == "]":
                        match += 1
        if self.code[self.ip] == "<":
            self.memory += 1
        if self.code[self.ip] == ">":
            self.memory -= 1
        if self.code[self.ip] == ",":
            self.code[self.ip] == 0
            self.input = True
        if self.code[self.ip] == ".":
            self.output += bytes([self.tape[self.memory]])


def decompress(code):
    program = BrainfuckProgram(code, 0, [0]*30000, 0, b"", b"")
    while True:
        try:
            program.instruction()
        except:
            return program.output


def code(n):
    program = ""
    i = 0
    while n > 0:
        n -= 1
        program += chr(n % 256)
        n //= 256
    return program


def compress(text):
    programs = []
    i = 0
    while True:
        for program in programs:
            try:
                if program.halted:
                    program.instruction()
            except:
                if program.output == text:
                    return program.code
                else:
                    program.halted = False
        programs.append(BrainfuckProgram(code(i), 0, [0]*30000, 0, b"", b""))
        programs[len(programs) - 1].halted = True
        i += 1
